/*
 Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
              tabela MENUOPER
 Objetivo: Gerar um log que vai registrar as alteraes na tabela MENUOPER, utilizando
             a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_MENUOPER' AND
                 TYPE   = 'TR' 		         AND
	              U.UID  = O.UID              AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_MENUOPER
GO


CREATE TRIGGER LOG_GER_MENUOPER
ON MENUOPER
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE  @V_ID_COMANDO     VARCHAR(1);

   DECLARE  @V_OLD_CDOPERADOR   VARCHAR(12);
   DECLARE  @V_OLD_CDSISTOPER   VARCHAR(10);
   DECLARE  @V_OLD_CDMENUITOPER VARCHAR(20);
   DECLARE  @V_OLD_DSCAPTIONOPE VARCHAR(80);
   DECLARE  @V_OLD_DSBPLOPER    VARCHAR(10);
   DECLARE  @V_OLD_NRTPMENUOPER DOUBLE PRECISION;
   DECLARE  @V_OLD_NRATALHOOPER DOUBLE PRECISION;
   DECLARE  @V_OLD_NRNIVELOPER  DOUBLE PRECISION;
   DECLARE  @V_OLD_NRPOSBOTOPER DOUBLE PRECISION;
   DECLARE  @V_OLD_NRMENUGROPER DOUBLE PRECISION;

   DECLARE  @V_NEW_CDOPERADOR   VARCHAR(12);
   DECLARE  @V_NEW_CDSISTOPER   VARCHAR(10);
   DECLARE  @V_NEW_CDMENUITOPER VARCHAR(20);
   DECLARE  @V_NEW_DSCAPTIONOPE VARCHAR(80);
   DECLARE  @V_NEW_DSBPLOPER    VARCHAR(10);
   DECLARE  @V_NEW_NRTPMENUOPER DOUBLE PRECISION;
   DECLARE  @V_NEW_NRATALHOOPER DOUBLE PRECISION;
   DECLARE  @V_NEW_NRNIVELOPER  DOUBLE PRECISION;
   DECLARE  @V_NEW_NRPOSBOTOPER DOUBLE PRECISION;
   DECLARE  @V_NEW_NRMENUGROPER DOUBLE PRECISION;


   BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDOPERADOR,
         CDSISTOPER,
         CDMENUITOPER,
         DSCAPTIONOPE,
         DSBPLOPER,
         NRTPMENUOPER,
         NRATALHOOPER,
         NRNIVELOPER,
         NRPOSBOTOPER,
         NRMENUGROPER,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

   FROM
      DELETED
   WHERE
      CDOPERADOR+CDSISTOPER+CDMENUITOPER NOT IN (SELECT CDOPERADOR+CDSISTOPER+CDMENUITOPER FROM INSERTED)
   UNION ALL

   SELECT
     'U' IDCOMANDO,
         DELETED.CDOPERADOR,
         DELETED.CDSISTOPER,
         DELETED.CDMENUITOPER,
         DELETED.DSCAPTIONOPE,
         DELETED.DSBPLOPER,
         DELETED.NRTPMENUOPER,
         DELETED.NRATALHOOPER,
         DELETED.NRNIVELOPER,
         DELETED.NRPOSBOTOPER,
         DELETED.NRMENUGROPER,
         INSERTED.CDOPERADOR,
         INSERTED.CDSISTOPER,
         INSERTED.CDMENUITOPER,
         INSERTED.DSCAPTIONOPE,
         INSERTED.DSBPLOPER,
         INSERTED.NRTPMENUOPER,
         INSERTED.NRATALHOOPER,
         INSERTED.NRNIVELOPER,
         INSERTED.NRPOSBOTOPER,
         INSERTED.NRMENUGROPER

   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDOPERADOR   = DELETED.CDOPERADOR   AND
      INSERTED.CDSISTOPER   = DELETED.CDSISTOPER   AND
      INSERTED.CDMENUITOPER = DELETED.CDMENUITOPER
   UNION ALL

   SELECT
     'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDOPERADOR,
         CDSISTOPER,
         CDMENUITOPER,
         DSCAPTIONOPE,
         DSBPLOPER,
         NRTPMENUOPER,
         NRATALHOOPER,
         NRNIVELOPER,
         NRPOSBOTOPER,
         NRMENUGROPER
   FROM
      INSERTED
   WHERE
      CDOPERADOR+CDSISTOPER+CDMENUITOPER NOT IN (SELECT CDOPERADOR+CDSISTOPER+CDMENUITOPER FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDOPERADOR,
                                 @V_OLD_CDSISTOPER,
                                 @V_OLD_CDMENUITOPER,
                                 @V_OLD_DSCAPTIONOPE,
                                 @V_OLD_DSBPLOPER,
                                 @V_OLD_NRTPMENUOPER,
                                 @V_OLD_NRATALHOOPER,
                                 @V_OLD_NRNIVELOPER,
                                 @V_OLD_NRPOSBOTOPER,
                                 @V_OLD_NRMENUGROPER,

                                 @V_NEW_CDOPERADOR,
                                 @V_NEW_CDSISTOPER,
                                 @V_NEW_CDMENUITOPER,
                                 @V_NEW_DSCAPTIONOPE,
                                 @V_NEW_DSBPLOPER,
                                 @V_NEW_NRTPMENUOPER,
                                 @V_NEW_NRATALHOOPER,
                                 @V_NEW_NRNIVELOPER,
                                 @V_NEW_NRPOSBOTOPER,
                                 @V_NEW_NRMENUGROPER;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDOPERADOR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Oper=' + @V_OLD_CDOPERADOR;
         END;
         IF @V_OLD_CDSISTOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SisOper=' + @V_OLD_CDSISTOPER;
         END;
         IF @V_OLD_CDMENUITOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' MnItOper=' + @V_OLD_CDMENUITOPER;
         END;
         IF @V_OLD_DSCAPTIONOPE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsCaptOper=' + @V_OLD_DSCAPTIONOPE;
         END;
         IF @V_OLD_DSBPLOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DsBplOper=' + @V_OLD_DSBPLOPER;
         END;
         IF @V_OLD_NRTPMENUOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TpMenuOper=' + CONVERT(VARCHAR,@V_OLD_NRTPMENUOPER);
         END;
         IF @V_OLD_NRATALHOOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' AtaOper=' + CONVERT(VARCHAR,@V_OLD_NRATALHOOPER);
         END;
         IF @V_OLD_NRNIVELOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NivOper=' + CONVERT(VARCHAR,@V_OLD_NRNIVELOPER);
         END;
         IF @V_OLD_NRPOSBOTOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' PosBotOper=' + CONVERT(VARCHAR,@V_OLD_NRPOSBOTOPER);
         END;
         IF @V_OLD_NRMENUGROPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NrMenu=' + CONVERT(VARCHAR,@V_OLD_NRMENUGROPER);
         END;
         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDOPERADOR+@V_OLD_CDSISTOPER+@V_OLD_CDMENUITOPER;
      END
      ELSE
      IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (ISNULL(@V_OLD_CDOPERADOR,'')   <> ISNULL(@V_NEW_CDOPERADOR,''))   OR
            (ISNULL(@V_OLD_CDSISTOPER,'')   <> ISNULL(@V_NEW_CDSISTOPER,''))   OR
            (ISNULL(@V_OLD_CDMENUITOPER,'') <> ISNULL(@V_NEW_CDMENUITOPER,'')) OR
            (ISNULL(@V_OLD_DSCAPTIONOPE,'') <> ISNULL(@V_NEW_DSCAPTIONOPE,'')) OR
            (ISNULL(@V_OLD_DSBPLOPER,'')    <> ISNULL(@V_NEW_DSBPLOPER,''))    OR
            (ISNULL(@V_OLD_NRTPMENUOPER,'') <> ISNULL(@V_NEW_NRTPMENUOPER,'')) OR
            (ISNULL(@V_OLD_NRATALHOOPER,'') <> ISNULL(@V_NEW_NRATALHOOPER,'')) OR
            (ISNULL(@V_OLD_NRNIVELOPER,'')  <> ISNULL(@V_NEW_NRNIVELOPER,''))  OR
            (ISNULL(@V_OLD_NRPOSBOTOPER,'') <> ISNULL(@V_NEW_NRPOSBOTOPER,'')) OR
            (ISNULL(@V_OLD_NRMENUGROPER,'') <> ISNULL(@V_NEW_NRMENUGROPER,'')) BEGIN

            IF ISNULL(@V_OLD_CDOPERADOR,'') <> ISNULL(@V_NEW_CDOPERADOR,'') BEGIN
               SET @V_DESC = @V_DESC + 'Oper=' + @V_NEW_CDOPERADOR;
            END;

            IF ISNULL(@V_OLD_CDSISTOPER,'') <> ISNULL(@V_NEW_CDSISTOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' SisOper=' + @V_NEW_CDSISTOPER;
            END;

            IF ISNULL(@V_OLD_CDMENUITOPER,'') <> ISNULL(@V_NEW_CDMENUITOPER,'') BEGIN
                SET @V_DESC = @V_DESC + ' MnItOper=' + @V_NEW_CDMENUITOPER;
            END;

            IF ISNULL(@V_OLD_DSCAPTIONOPE,'') <> ISNULL(@V_NEW_DSCAPTIONOPE,'') BEGIN
               SET @V_DESC = @V_DESC + ' DsCaptOper=' + @V_NEW_DSCAPTIONOPE;
            END;

            IF ISNULL(@V_OLD_DSBPLOPER,'') <> ISNULL(@V_NEW_DSBPLOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' DsBplOper=' + @V_NEW_DSBPLOPER;
            END;

            IF ISNULL(@V_OLD_NRTPMENUOPER,'') <> ISNULL(@V_NEW_NRTPMENUOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' TpMenuOper=' + CONVERT(VARCHAR,@V_NEW_NRTPMENUOPER);
            END;

            IF ISNULL(@V_OLD_NRATALHOOPER,'') <> ISNULL(@V_NEW_NRATALHOOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' AtaOper=' + CONVERT(VARCHAR,@V_NEW_NRATALHOOPER);
            END;

            IF ISNULL(@V_OLD_NRNIVELOPER,'') <> ISNULL(@V_NEW_NRNIVELOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' NivOper=' + CONVERT(VARCHAR,@V_NEW_NRNIVELOPER);
            END;

            IF ISNULL(@V_OLD_NRPOSBOTOPER,'') <> ISNULL(@V_NEW_NRPOSBOTOPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' PosBotOper=' + CONVERT(VARCHAR,@V_NEW_NRPOSBOTOPER);
            END;

            IF ISNULL(@V_OLD_NRMENUGROPER,'') <> ISNULL(@V_NEW_NRMENUGROPER,'') BEGIN
               SET @V_DESC = @V_DESC + ' NrMenu=' + CONVERT(VARCHAR,@V_NEW_NRMENUGROPER);
            END;

            SET @V_TIPO         = '2';
            SET @V_ITPESQ       = @V_NEW_CDOPERADOR+@V_NEW_CDSISTOPER+@V_NEW_CDMENUITOPER;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO         = '1';
         SET @V_ITPESQ       = @V_NEW_CDOPERADOR+@V_NEW_CDSISTOPER+@V_NEW_CDMENUITOPER;
         IF ISNULL(@V_OLD_CDOPERADOR,'') <> ISNULL(@V_NEW_CDOPERADOR,'') BEGIN
           SET @V_DESC = @V_DESC + 'Oper=' + @V_NEW_CDOPERADOR;
         END;

         IF ISNULL(@V_OLD_CDSISTOPER,'') <> ISNULL(@V_NEW_CDSISTOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' SisOper=' + @V_NEW_CDSISTOPER;
         END;

         IF ISNULL(@V_OLD_CDMENUITOPER,'') <> ISNULL(@V_NEW_CDMENUITOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' MnItOper=' + @V_NEW_CDMENUITOPER;
         END;

         IF ISNULL(@V_OLD_DSCAPTIONOPE,'') <> ISNULL(@V_NEW_DSCAPTIONOPE,'') BEGIN
           SET @V_DESC = @V_DESC + ' DsCaptOper=' + @V_NEW_DSCAPTIONOPE;
         END;

         IF ISNULL(@V_OLD_DSBPLOPER,'') <> ISNULL(@V_NEW_DSBPLOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' DsBplOper=' + @V_NEW_DSBPLOPER;
         END;

         IF ISNULL(@V_OLD_NRTPMENUOPER,'') <> ISNULL(@V_NEW_NRTPMENUOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' TpMenuOper=' + CONVERT(VARCHAR,@V_NEW_NRTPMENUOPER);
         END;

         IF ISNULL(@V_OLD_NRATALHOOPER,'') <> ISNULL(@V_NEW_NRATALHOOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' AtaOper=' + CONVERT(VARCHAR,@V_NEW_NRATALHOOPER);
         END;

         IF ISNULL(@V_OLD_NRNIVELOPER,'') <> ISNULL(@V_NEW_NRNIVELOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' NivOper=' + CONVERT(VARCHAR,@V_NEW_NRNIVELOPER);
         END;

         IF ISNULL(@V_OLD_NRPOSBOTOPER,'') <> ISNULL(@V_NEW_NRPOSBOTOPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' PosBotOper=' + CONVERT(VARCHAR,@V_NEW_NRPOSBOTOPER);
         END;

         IF ISNULL(@V_OLD_NRMENUGROPER,'') <> ISNULL(@V_NEW_NRMENUGROPER,'') BEGIN
           SET @V_DESC = @V_DESC + ' NrMenu=' + CONVERT(VARCHAR,@V_NEW_NRMENUGROPER);
         END;

      END;
      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('MENUOPER',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, @V_DESC);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDOPERADOR,
                                    @V_OLD_CDSISTOPER,
                                    @V_OLD_CDMENUITOPER,
                                    @V_OLD_DSCAPTIONOPE,
                                    @V_OLD_DSBPLOPER,
                                    @V_OLD_NRTPMENUOPER,
                                    @V_OLD_NRATALHOOPER,
                                    @V_OLD_NRNIVELOPER,
                                    @V_OLD_NRPOSBOTOPER,
                                    @V_OLD_NRMENUGROPER,

                                    @V_NEW_CDOPERADOR,
                                    @V_NEW_CDSISTOPER,
                                    @V_NEW_CDMENUITOPER,
                                    @V_NEW_DSCAPTIONOPE,
                                    @V_NEW_DSBPLOPER,
                                    @V_NEW_NRTPMENUOPER,
                                    @V_NEW_NRATALHOOPER,
                                    @V_NEW_NRNIVELOPER,
                                    @V_NEW_NRPOSBOTOPER,
                                    @V_NEW_NRMENUGROPER;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_MENUOPER','4.11.105';
GO
